    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ----------------------
    028     * DefaultKeyedValue.java
    029     * ----------------------
    030     * (C) Copyright 2002-2005, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * $Id: DefaultKeyedValue.java,v 1.6.2.1 2005/10/25 21:29:13 mungady Exp $
    036     *
    037     * Changes:
    038     * --------
    039     * 31-Oct-2002 : Version 1 (DG);
    040     * 13-Mar-2003 : Added equals() method, and implemented Serializable (DG);
    041     * 18-Aug-2003 : Implemented Cloneable (DG);
    042     * 18-Aug-2004 : Moved from org.jfree.data --> org.jfree.data.base (DG);
    043     * 15-Sep-2004 : Added PublicCloneable interface (DG);
    044     *
    045     */
    046
    047    package org.jfree.data;
    048
    049    import java.io.Serializable;
    050
    051    import org.jfree.util.PublicCloneable;
    052
    053    /**
    054     * A (key, value) pair.  This class provides a default implementation
    055     * of the {@link KeyedValue} interface.
    056     */
    057    public class DefaultKeyedValue implements KeyedValue,
    058                                              Cloneable, PublicCloneable,
    059                                              Serializable {
    060
    061        /** For serialization. */
    062        private static final long serialVersionUID = -7388924517460437712L;
    063
    064        /** The key. */
    065        private Comparable key;
    066
    067        /** The value. */
    068        private Number value;
    069
    070        /**
    071         * Creates a new (key, value) item.
    072         *
    073         * @param key  the key (should be immutable).
    074         * @param value  the value (<code>null</code> permitted).
    075         */
    076        public DefaultKeyedValue(Comparable key, Number value) {
    077            this.key = key;
    078            this.value = value;
    079        }
    080
    081        /**
    082         * Returns the key.
    083         *
    084         * @return The key.
    085         */
    086        public Comparable getKey() {
    087            return this.key;
    088        }
    089
    090        /**
    091         * Returns the value.
    092         *
    093         * @return The value (possibly <code>null</code>).
    094         */
    095        public Number getValue() {
    096            return this.value;
    097        }
    098
    099        /**
    100         * Sets the value.
    101         *
    102         * @param value  the value (<code>null</code> permitted).
    103         */
    104        public synchronized void setValue(Number value) {
    105            this.value = value;
    106        }
    107
    108        /**
    109         * Tests this key-value pair for equality with an arbitrary object.
    110         *
    111         * @param obj  the object (<code>null</code> permitted).
    112         *
    113         * @return A boolean.
    114         */
    115        public boolean equals(Object obj) {
    116            if (obj == this) {
    117                return true;
    118            }
    119            if (!(obj instanceof DefaultKeyedValue)) {
    120                return false;
    121            }
    122            // TODO: modify this so that we check for equality with any KeyedValue
    123            // rather than specifically a DefaultKeyedValue
    124            DefaultKeyedValue that = (DefaultKeyedValue) obj;
    125
    126            // TODO: the following checks for null should be handled in a utility
    127            // method
    128            if (this.key != null ? !this.key.equals(that.key) : that.key != null) {
    129                return false;
    130            }
    131            if (this.value != null
    132                    ? !this.value.equals(that.value) : that.value != null) {
    133                return false;
    134            }
    135            return true;
    136        }
    137
    138        /**
    139         * Returns a hash code.
    140         *
    141         * @return A hash code.
    142         */
    143        public int hashCode() {
    144            int result;
    145            result = (this.key != null ? this.key.hashCode() : 0);
    146            result = 29 * result + (this.value != null ? this.value.hashCode() : 0);
    147            return result;
    148        }
    149
    150        /**
    151         * Returns a clone.  It is assumed that both the key and value are
    152         * immutable objects, so only the references are cloned, not the objects
    153         * themselves.
    154         *
    155         * @return A clone.
    156         *
    157         * @throws CloneNotSupportedException Not thrown by this class, but
    158         *         subclasses (if any) might.
    159         */
    160        public Object clone() throws CloneNotSupportedException {
    161            DefaultKeyedValue clone = (DefaultKeyedValue) super.clone();
    162            return clone;
    163        }
    164
    165    }